unit Kopy_error;

interface

uses
   Windows, Forms, StrUtils, ExtCtrls, ComCtrls, StdCtrls,
   Controls, Classes, Dialogs, SysUtils, FileCtrl, Graphics, 
   Kopy_functions, act_thread;

type
   TkopyForm = class(TForm)
     OpenDialog1: TOpenDialog;
     SaveDialog1: TSaveDialog;
     Timer1: TTimer;
     Button1: TButton;
     Button2: TButton;
     Button3: TButton;
     Button4: TButton;
     Edit5: TEdit;
     Edit6: TComboBox;
     Label1: TLabel;
     Label2: TLabel;
     Label3: TLabel;
     Label4: TLabel;
     lbproz: TLabel;
     lbprog: TLabel;
     Label8: TLabel;
     Label9: TLabel;
     Label12: TLabel;
     Label13: TLabel;
     Label14: TLabel;
     lbproztotal: TLabel;
     Label11: TLabel;
     lbprogtotal: TLabel;
     Label10: TLabel;
     ckb1: TCheckBox;
     ckb2: TCheckBox;
     progbar1: TProgressBar;
     progbar2: TProgressBar;
     Panel1: TPanel;
     Panel2: TPanel;
     Memo1: TMemo;
     Edit1: TEdit;
     Edit2: TEdit;
     ckb3: TCheckBox;
     PaintBox1: TPaintBox;
     Panel3: TPanel;
     Splitter1: TSplitter;
     procedure FormCreate(Sender: TObject);
     procedure FormResize(Sender: TObject);
     procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
     procedure Timer1Timer(Sender: TObject);
     procedure Button1Click(Sender: TObject);
     procedure Button3Click(Sender: TObject);
     procedure Button2Click(Sender: TObject);
     procedure Button4Click(Sender: TObject);
     procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
     procedure Edit1Change(Sender: TObject);
     procedure Edit5Change(Sender: TObject);
     procedure ckb2Click(Sender: TObject);
     function  CheckForFreeSpace : integer;
     procedure Splitter1Moved(Sender: TObject);
     procedure PaintBox1DblClick(Sender: TObject);
   private
     { Private-Deklarationen }
     procedure start();
     procedure RefreshSpeed();
   public
     { Public-Deklarationen }
     SrcPath, DestPath, Filter: string;
     procedure ActWin;
	   //function FmtStr(number: real; startIdx: integer; chr: char; decimalPoint: integer): string;
end;

var
   kF      : TkopyForm;
   tcheck  : TThreadCheck;

   // if something added, then add to Edit6-combo too
   (*
   buf419  : array[0..4194304-1] of char;
   buf209  : array[0..2097152-1] of char;
   buf524  : array[0..524288 -1] of char;
   buf131  : array[0..131072 -1] of char;
   buf327  : array[0..32768  -1] of char;
   buf819  : array[0..8192   -1] of char;
   buf204  : array[0..2048   -1] of char;
   buf512  : array[0..512    -1] of char;
   buf128  : array[0..128    -1] of char;
   buf32   : array[0..32     -1] of char;
   buf8    : array[0..8      -1] of char;
   buf1    : array[0..1      -1] of char;
   *)

   CopyBuffer         : Pointer;

   lastEdit6Text      : string;
   blocksize          : Cardinal;
   greatestblockindex : integer;
   spinupcounter      : integer;
   spinupval          : integer;

   val_code, c_error  : Integer;
   c_files_total,
   c_paths_total      : LongWord;
   c_bytes_total,
   c_bytes_destination,
   c_bytes_left       : Int64;
   DiskSizeFree, 
   DiskSizeTotal      : Int64;

   lastsize, forelastsize: Int64;

   currdiff, overalldiff, maxspeed, minspeed : double;
   timestart, timeend : TDateTime;
   lasttime           : Longint;

   notoall, yestoall, breakonerror: Boolean;
   DriveType          : Cardinal;
   vis_faktor         : LongInt;
   overwritten        : boolean;
   userchange         : boolean;

   SpeedCounter       : Longint;
   SpeedArr           : array [0..1024] of LongInt;
   //intext, outtext         : Byte8Type;
   //skey                    : Byte8Type;
   //logfile : TFileStream;
   //logfile : TextFile;

implementation

{$R *.dfm}

procedure TkopyForm.FormCreate(Sender: TObject);
begin
   //hkl:=TmoHotkeyLister.C

   Edit5.Text    := '2'; // set retry default
   Edit6.ItemIndex := 5;
   if (ParamStr(1) <> '') then begin
      Edit1.Text := ParamStr(1);
      Edit2.Text := Paramstr(2);
      Edit1Change(Sender);
   end else
      Edit6.ItemIndex := 7;

   maxspeed      := 0;
   minspeed      := 100000;
   spinupcounter := 0;
   spinupval     := 0;
   ClientHeight  := 73;
   userchange    := False;
end;

function TkopyForm.CheckForFreeSpace : integer;
begin
   result := mrOk;
   if (DiskSizeFree < c_bytes_left) then begin
      result := MessageDlg('Not enough Space on Destination Drive ' + Copy(kF.DestPath, 1, 3) + '. ' + Chr(13) + Chr(13) +
         FloatToStrF(c_bytes_left                      , ffNumber, 15, 0) + ' byte (' +
         FloatToStrF(c_bytes_left  / 1024 / 1024       , ffNumber, 15, 0) + ' MB / ' +
         FloatToStrF(c_bytes_left  / 1024 / 1024 / 1024, ffNumber, 15, 1) + ' GB) ' +
         ' needed.' + Chr(13) +
         FloatToStrF(DiskSizeFree                      , ffNumber, 15, 0) + ' byte (' +
         FloatToStrF(DiskSizeFree  / 1024 / 1024       , ffNumber, 15, 0) + ' MB / ' +
         FloatToStrF(DiskSizeFree  / 1024 / 1024 / 1024, ffNumber, 15, 1) + ' GB) ' +
         ' available of ' +
         FloatToStrF(DiskSizeTotal / 1024 / 1024       , ffNumber, 15, 0) + ' MB (' +
         FloatToStrF(DiskSizeTotal / 1024 / 1024 / 1024, ffNumber, 15, 1) + ' GB).' +
         Chr(13) + Chr(13) + 'Continue?',
         mtConfirmation, mbOKCancel, 0);
   end;
   timestart := Time;
end;

procedure TkopyForm.ActWin;
begin
   Application.ProcessMessages;
end;

procedure TkopyForm.Edit1Change(Sender: TObject);
begin
   if Button3.Cancel then exit;
   DriveType := GetDriveType(PChar(Copy(Edit1.Text, 1, 1) + ':/'));
   case DriveType of { Positive Werte bedeuten gltige Laufwerke }
      DRIVE_REMOVABLE, DRIVE_CDROM, DRIVE_UNKNOWN:
      begin
         Edit6.ItemIndex := 7;  //CD's or ..       2k blocksize
      end;
      DRIVE_FIXED, DRIVE_RAMDISK, DRIVE_NO_ROOT_DIR, DRIVE_REMOTE:
      begin
         Edit6.ItemIndex := 11;   //HDD's, NetWork 65k blocksize
      end;
   end;
end;

procedure TkopyForm.ckb2Click(Sender: TObject);
begin
   if ckb2.checked then begin
      Button3.Caption := '&del';
      Edit2.Enabled := false
   end else begin
      Button3.Caption := '&kopy';
      Edit2.Enabled := true
   end;
end;

procedure TkopyForm.Button1Click(Sender: TObject);
var dir  : String;
    opts : TSelectDirOpts;
begin
(*
   dir  := '';
   opts := [sdAllowCreate,sdPerformCreate,sdPrompt];

   //if SelectDirectory(dir, opts, 0) then
   SelectDirectory('sele', '', dir);
   if dir <> '' then
     Edit1.text := dir;
*)

   OpenDialog1.DefaultExt:='*.*';
   OpenDialog1.FileName:='*.*';
   OpenDialog1.Filter:='*.*';

   //OpenDialog1.Options:=[ofAllowMultiSelect];
   if OpenDialog1.Execute then
     Edit1.text := OpenDialog1.FileName;

end;

procedure TkopyForm.Button2Click(Sender: TObject);
var OutDir: string;
begin
   if (Pos('*', Edit1.text) = 0) and (Pos('?', Edit1.text) = 0) then begin
     if FileExists(Edit1.text) then
       SaveDialog1.FileName := ExtractFileName(Edit1.text);
     if SaveDialog1.Execute then
       Edit2.text := SaveDialog1.FileName;
   end else begin
     if SelectDirectory('Output Directory', '', OutDir) then
     Edit2.text := OutDir;
   end;
end;

procedure TkopyForm.Button3Click(Sender: TObject);
begin
   randomize;
(*
   if ckb2.Checked then begin
      if (DriveType = DRIVE_CDROM) then begin
         MessageDlg('Cannot delete on CDROM.', mtInformation, [mbOK], 0);
         exit;
      end;
      if (edit1.Text='') or
         (pos('\', edit1.Text) = 0) or
         (pos(':', edit1.Text) = 0) then begin
         MessageDlg('Invalid Path.', mtInformation, [mbOK], 0);
         exit;
      end;
   end else begin
      if (edit1.Text='') or
         (pos('\', edit1.Text) = 0) or
         (pos(':', edit1.Text) = 0) or
         (edit2.Text='') or
         (pos('\', edit2.Text) = 0) or
         (pos(':', edit2.Text) = 0) then begin
         MessageDlg('Invalid Paths.', mtInformation, [mbOK], 0);
         exit;
      end;
   end;
*)
   if Button3.Cancel then begin
     if ckb2.checked then 
        Button3.Caption := '&del'
     else 
        Button3.Caption := '&kopy';
     Button3.Enabled := False;
     Button3.Cancel := False;
     Button3.ShowHint := True;
     exit;
   end else begin
     Button3.Caption := '&cancel';
     Button3.Cancel := True;
   end;
   if (ClientHeight < 166) then ClientHeight := 166;
    start;
end;

procedure TkopyForm.Button4Click(Sender: TObject);
begin
   Close;
end;

procedure TkopyForm.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   Edit1Change(Sender);
end;

procedure TkopyForm.FormResize(Sender: TObject);
begin
   Application.ProcessMessages;
   Label3.Left := ClientWidth - 75;
   Edit6.Left := ClientWidth - 75;
   //ckb1.Left := ClientWidth - 75;
   //ckb2.Left := ClientWidth - 35;
   ckb3.Left := ClientWidth - 75;
   Button1.Left := ClientWidth - 100;
   Button2.Left := ClientWidth - 100;
   Button3.Left := ClientWidth - 75;
   Button4.Left := ClientWidth - 28;
   Edit1.Width := ClientWidth - 140;
   Edit2.Width := ClientWidth - 140;
   Label13.Width := ClientWidth - 5;
   Label14.Width := ClientWidth - 5;
   progbar1.Width := ClientWidth - 85;
   progbar2.Width := ClientWidth - 85;
   lbproz.Left := ClientWidth - 80;
   lbproztotal.Left := ClientWidth - 80;
   Label8.Left := ClientWidth - 195;
   Label12.Left := Trunc(progbar2.Width / 2) - 35;
   Label10.Left := ClientWidth - 195;
   Panel3.Height := ClientHeight - 185;
   //Memo1.Height := ClientHeight - 185;

   if not kF.Button3.Cancel then RefreshSpeed;
end;

procedure TkopyForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   if Button3.Cancel then begin
      if ckb2.checked then Button3.Caption := '&del'
                  else Button3.Caption := '&kopy';
      Button3.Cancel := False;
   end;
end;

procedure TkopyForm.start();
var s_tmp, Src1, Dest1 : string;
    i                  : integer;
  	DirInfo            : TSearchRec;
    drvstring          : PChar;
    dwSectorsPerCluster, dwBytesPerSector, dwFreeClusters, dwTotalClusters : Cardinal;
begin
   Button1.Enabled := False;
   Button2.Enabled := False;
   Edit2.Enabled   := False;
   Edit1.Enabled   := False;
   ckb1.Enabled    := False;
   ckb2.Enabled    := False;
   notoall         := False;
   yestoall        := False;
   c_bytes_left        := 0;
   c_bytes_total       := 0;
   c_bytes_destination := 0;
   overalldiff := 0;
   lasttime := 0;
   SpeedCounter := 0;
   maxspeed := 0;
   lastsize := 0;
   forelastsize := 0;
   Edit6.SetFocus;

   overwritten :=False;
   breakonerror := False;
   // remember first blocksize for dynamic change of blocksize
   greatestblockindex := Edit6.ItemIndex;

   Cursor := crHourGlass; { Cursor Sanduhr }

   // make blocksize from list-value
   Val(kF.Edit6.Text, blocksize, val_code);
   GetMem(CopyBuffer, blocksize);
   ZeroMemory(CopyBuffer, blocksize);
   vis_faktor      := blocksize;
   lastEdit6Text   := kF.Edit6.Text;

   if (Pos('*', Edit1.text) = 0) and (Pos('?', Edit1.text) = 0) then begin
      // there are no wildcards
      if DirectoryExists(Edit1.Text) then begin
         // this is a valid path
         s_tmp := Copy(Edit1.Text, Length(Edit1.Text), 1);
         if s_tmp <> '\' then Edit1.Text := Edit1.Text + '\';
         Edit1.Text := Edit1.Text + '*.*';
      end else begin
         if FileExists(Edit1.text) and
            ((pos('\', edit2.Text) = 0) or
            (pos(':', edit2.Text) = 0)) and
            not ( ExtractFileName(Edit1.text) =
                ExtractFileName(Edit2.text)   ) then begin
            // this is only one file
            s_tmp := Copy(Edit2.Text, Length(Edit2.Text), 1);
            if (s_tmp = '\') then
               Edit2.Text := Edit2.Text + ExtractFileName(Edit1.text)
            else
               Edit2.Text := Edit2.Text + '\' + ExtractFileName(Edit1.text);
         end else begin

         end;
      end;
   end else begin
      // there are wildcards - make shure they are the same in src and dest
      if not ckb2.Checked then begin

        if DirectoryExists(Edit2.Text) then
          Edit2.Text := Edit2.Text + '\' + ExtractFileName(Edit1.text);

        Edit2.Text := ExtractFilePath(Edit2.Text);
        s_tmp := Copy(Edit2.Text, Length(Edit2.Text), 1);
        if s_tmp <> '\' then Edit2.Text := Edit2.Text + '\';
        Edit2.Text := Edit2.Text + ExtractFileName(Edit1.Text);

        if ExtractFileName(Edit1.text) <> ExtractFileName(Edit2.text) then
          Edit2.text :=
            ExtractFilePath(Edit2.text) +
            ExtractFileName(Edit1.text);
      end;
   end;

   if (Pos('*', Edit2.text) = 0) and
      (Pos('?', Edit2.text) = 0) and
      ((pos('\', edit2.Text) = 0) or
       (pos(':', edit2.Text) = 0)) and
      not ckb2.Checked and
      not (ExtractFileName(Edit1.text)=
           ExtractFileName(Edit2.text) ) then
   begin
      s_tmp := Copy(Edit2.Text, Length(Edit2.Text), 1);
      if (s_tmp <> '\') then Edit2.Text := Edit2.Text + '\';

      if FileExists(Edit1.text) then begin
         // this is only one file
         Edit2.Text := Edit2.Text + ExtractFileName(Edit1.text)
      end;
   end else begin
      if ((Pos('*', Edit1.text) <> 0) or
          (Pos('?', Edit1.text) <> 0)    ) and
         not ckb2.Checked and
         (ExtractFileName(Edit1.text) <>
         ExtractFileName(Edit2.text)        )then begin
         Edit2.Text := Edit2.Text + '\' + ExtractFileName(Edit1.text);
      end;
   end;

   Application.ProcessMessages;

   i := Length(Edit1.text);
   while Edit1.text[i] <> '\' do Dec(i);
   SrcPath := Copy(Edit1.text, 1, i);
   Filter := Copy(Edit1.text, i+1, Length(Edit1.Text));
   if (not ckb2.Checked) then begin
     i := Length(Edit2.text);
     while (Edit2.text[i] <> '\') and (not ckb2.Checked) do Dec(i);
     DestPath := Copy(Edit2.text, 1, i);
   end;
   Src1 := SrcPath; Dest1 := DestPath;

   SetCurrentDir(Copy(DestPath, 1, 2));
   (*
   drvstring:=(DestPath, 1, 2);
   GetDiskFreeSpace(drvstring,
                    dwSectorsPerCluster, dwBytesPerSector,
                    dwFreeClusters, dwTotalClusters);
   *)
   DiskSizeFree := DiskFree(0);
   DiskSizeTotal:= DiskSize(0);

   if ClientHeight<360 then ClientHeight := 360;
   Memo1.Visible := True;
   
   if (Pos('*', Edit1.text) = 0) and (Pos('?', Edit1.text) = 0)
   then begin
      // this is one single file
      c_bytes_total := FileSizeByName(Edit1.Text);
      if not FileExists(Edit1.Text) then
        MessageDlg('File not found', mtError, [mbOK], 0)
      else begin
        if ckb2.Checked then begin
         Memo1.Lines.Add(FloatToStrF(c_bytes_total, ffNumber, 15, 0) +
           ' byte - 1 file will be overwritten and deleted ...');
         Label10.Caption := FloatToStrF(c_bytes_total, ffNumber, 15, 0);
         TCheck := TThreadCheck.Create;
         timestart := Time;
         Timer1.Enabled := True;
         delthefile(Edit1.text, overwritten);
         overwritten := True;
         if kF.Button3.Cancel then
         delthefile(Edit1.text, overwritten);
        end else begin
         if FileExists(Edit2.Text) then
            c_bytes_destination := FileSizeByName(Edit2.Text)
         else
            c_bytes_destination := 0;

         c_bytes_left := c_bytes_total-c_bytes_destination;
         if CheckForFreeSpace = mrOk then begin
           TCheck := TThreadCheck.Create;
           timestart := Time;
           Timer1.Enabled := True;
           Memo1.Lines.Add(FloatToStrF(c_bytes_total, ffNumber, 15, 0) +
               ' byte - 1 file to kopy ...');
           if (c_bytes_left < c_bytes_total) and (c_bytes_left>0) then begin
               s_tmp := '... ' + FloatToStrF(c_bytes_left, ffNumber, 15, 0) + ' byte left ...';
               Memo1.Lines.Add(s_tmp);
           end;
           Label10.Caption := FloatToStrF(c_bytes_total, ffNumber, 15, 0);
           kopythefile(Edit1.text, Edit2.text);
         end else
            lbproz.Caption := 'canceled by user';
        end;
      end;
   end else begin
      // this is a path with wildcards

      SrcPath := Src1; DestPath := Dest1;
      //c_bytes_total := Directories1(Src1, Dest1, Filter); // count source dir
      c_bytes_total := Directories2(Src1, Dest1, Filter); // count source dir
      SrcPath := Src1; DestPath := Dest1;

      if (c_files_total = 1) then begin
        FindFirst(Edit1.Text, faAnyFile, DirInfo);
        Edit1.Text:=ExtractFilePath(Edit1.Text)+Dirinfo.Name;
	    	FindClose(DirInfo);
        c_bytes_total := 0;  
        if FileExists(Edit1.Text) then
          c_bytes_total := FileSizeByName(Edit1.Text);

        Edit2.Text:=ExtractFilePath(Edit2.Text)+ExtractFileName(Edit1.Text);
        c_bytes_destination := 0;
        if FileExists(Edit2.Text) then
            c_bytes_destination := FileSizeByName(Edit2.Text);
        c_bytes_left := c_bytes_total-c_bytes_destination;
        //lastsize := c_bytes_destination;
      end else begin
        c_bytes_left := c_bytes_total-c_bytes_destination;
        //lastsize := c_bytes_destination;
      end;

      if ckb2.Checked then begin
         if (c_files_total>1) then
            s_tmp :=     FloatToStrF(c_bytes_total, ffNumber, 15, 0) +
               ' byte - ' + IntToStr(c_files_total) +
            ' file(s) - ' + IntToStr(c_paths_total) + ' dir(s) will be overwritten and deleted ...'
         else
            s_tmp:=      FloatToStrF(c_bytes_total, ffNumber, 15, 0) +
               ' byte - 1 file will be overwritten and deleted ...';
         Memo1.Lines.Add(s_tmp);
      end else begin
         if (c_files_total>1) then
            s_tmp :=     FloatToStrF(c_bytes_total, ffNumber, 15, 0) +
               ' byte - ' + IntToStr(c_files_total) +
            ' file(s) - ' + IntToStr(c_paths_total) + ' dir(s) to kopy ... '
         else
            s_tmp :=     FloatToStrF(c_bytes_total, ffNumber, 15, 0) +
               ' byte - 1 file to kopy ...';
         Memo1.Lines.Add(s_tmp);
         if (c_bytes_left < c_bytes_total) and (c_bytes_left>0) then begin
            s_tmp := '... ' + FloatToStrF(c_bytes_left, ffNumber, 15, 0) + ' byte left ...';
            Memo1.Lines.Add(s_tmp);
         end;
      end;

      if (c_bytes_left <= c_bytes_total) and (c_bytes_left>0) then
        if CheckForFreeSpace = mrOk then begin

         tcheck := TThreadCheck.Create;
         timestart := Time;
         Timer1.Enabled := True;

         Label10.Caption := FloatToStrF(c_bytes_total, ffNumber, 15, 0);
         Label10.Refresh;

         lbprogtotal.Caption := FloatToStrF(c_bytes_destination, ffNumber, 15, 0);

         //Directories1(Src1, Dest1, Filter); // first to kopy or delete content
         Directories2(Src1, Dest1, Filter); // first to kopy or delete content
         SrcPath := Src1; DestPath := Dest1;

         if (ckb2.Checked) and (kF.Button3.Cancel) then begin
            overwritten := true;
            //Directories1(Src1, Dest1, Filter); // second to kill filenames
            Directories2(Src1, Dest1, Filter); // second to kill filenames
         end;
        end else
         lbproz.Caption := 'canceled by user'
      else 
        Memo1.Lines.Add('... already ...');
   end;

   Timer1.Enabled := False;
   timeend := Time;
   timeend := (timeend - timestart) * 100000;
   Label14.Caption := FloatToStrF(timeend, ffNumber, 15, 2) + ' sec. -- ';
   if lasttime<1 then lasttime:=1;
   if (timeend > 0) then
      Label14.Caption := Label14.Caption +
         FloatToStrF(lastsize / lasttime / 1024, ffNumber, 15, 2) + ' kByte/s (max: '+
         FloatToStrF(maxspeed                  , ffNumber, 15, 0) + ' kByte/s, min: '+
         FloatToStrF(minspeed                  , ffNumber, 15, 0) + ' kByte/s)';

   if (lbproz.Caption <> '') then begin
      Memo1.Lines.Add('...' + lbproz.Caption + lbproztotal.Caption + '.');
      lbproz.Caption := '';
      lbproztotal.Caption := '';
   end else begin
      lbproz.Caption := '';
      Memo1.Lines.Add('...done.');
      lbproztotal.Caption := '';
   end;

   if ckb2.checked then Button3.Caption := '&del'
               else Button3.Caption := '&kopy';

   FreeMem(CopyBuffer, blocksize); { free the buffer }
   Caption           := 'kopy errorness files';
   progbar2.Position := 0;
   progbar1.Position := 0;
   lbprogtotal.Caption := '';
   label8.Caption := '';
   lbprog.Caption := '';
   label10.Caption := '';
   label12.Caption := '';
   Label13.Caption := '';
   Edit6.ItemIndex   := greatestblockindex;
   Cursor := crDefault;
   Button3.Cancel := False;
   Button1.Enabled := True;
   Button2.Enabled := True;
   Button3.Enabled := True;
   Edit2.Enabled := True;
   Edit1.Enabled := True;
   ckb1.Enabled := True;
   ckb2.Enabled := True;
end;

procedure TkopyForm.Edit5Change(Sender: TObject);
begin
   userchange:=True;
end;

procedure ShiftDownSpeedArray();
var i : Integer;
begin
  for i:=0 to 1023 do
    SpeedArr[i]:=SpeedArr[i+1]
end;

procedure TkopyForm.RefreshSpeed();
var i           : Integer;
    start, ende : Integer;
    P           : TPoint;
begin
   if SpeedCounter=0 then exit;
   PaintBox1.Canvas.Brush.Color:=clBtnFace;
   PaintBox1.Canvas.Pen.Color:=clBtnFace;
   PaintBox1.Canvas.Rectangle(0,0,PaintBox1.Width, PaintBox1.Height);
   PaintBox1.Canvas.Pen.Color:=clBlack;

   if PaintBox1.Width<SpeedCounter then
     start := SpeedCounter - PaintBox1.Width
   else
     start := 0;
   ende  := SpeedCounter;
   for i:=ende downto start do begin
     if maxspeed=0 then maxspeed := SpeedArr[i];
     P.X:=PaintBox1.Width - ende + i;
     P.Y:=1+PaintBox1.Height - Trunc(PaintBox1.Height * ((SpeedArr[i  ]*100) / maxspeed)/100);
     PaintBox1.Canvas.PenPos:=P;

     P.X:=PaintBox1.Width - ende + i - 1;
     P.Y:=1+PaintBox1.Height - Trunc(PaintBox1.Height * ((SpeedArr[i-1]*100) / maxspeed)/100);
     PaintBox1.Canvas.LineTo(P.X, P.Y);
   end;
   PaintBox1.Canvas.TextOut(1,PaintBox1.Height-15, 'max: ' + IntToStr(Trunc(maxspeed/1000)) + 'MB/s');
end;

procedure TkopyForm.Timer1Timer(Sender: TObject);
var i : Longint;
    s : string;
begin
   ActWin;
   if not Button3.Cancel then exit;
   currdiff := (lastsize - forelastsize) / timer1.Interval;
   Inc(lasttime);
   if (currdiff > 0) and (lastsize>0) then begin
      if forelastsize<>0 then begin
         if (currdiff > maxspeed) then begin
             maxspeed:=currdiff;
         end;
         if (currdiff < minspeed) then minspeed:=currdiff;
         overalldiff := (((lastsize - c_bytes_destination) / lasttime / timer1.Interval) + overalldiff) / 2;
         if overalldiff<0 then begin
             s:='';
         end else begin
             i:=Trunc((c_bytes_total - lastsize) / overalldiff);
             s := '[' + IntToTime(i/1000) + ' left]';
         end;
         s :='kb/s: ' + FloatToStrF(   currdiff, ffNumber, 15, 0) + ' avg:'
                      + FloatToStrF(overalldiff, ffNumber, 15, 0) + ' ' + s;
         Caption := s;

         if SpeedCounter < 1024 then begin
           Inc(SpeedCounter);
           SpeedArr[SpeedCounter]:=Trunc(currdiff);
         end else begin
           ShiftDownSpeedArray;
           SpeedArr[SpeedCounter]:=Trunc(currdiff);
         end;
         RefreshSpeed;
      end;
   end;

   forelastsize := lastsize;
end;

procedure TkopyForm.Splitter1Moved(Sender: TObject);
begin
  RefreshSpeed;
end;

procedure TkopyForm.PaintBox1DblClick(Sender: TObject);
begin
  Memo1.Clear;
end;

end.

