unit Kopy_functions;

interface

uses Windows, SysUtils, Dialogs, Controls, Kopy_thread, Classes, Math;

// forward-declaration
function  Directories1(SrcPath: string; DestPath: string; filter: string) : Int64;
function  Directories2(SrcPath: string; DestPath: string; filter: string) : Int64;
procedure kopythefile(Quelle, Ziel: string);
procedure delthefile(filename: string; deletefile: boolean);
procedure SysErrMsg(ErrCode: Integer; S: string);
function  FileSizeByName(sFilename: string): Int64;
Function  countStr(Number, pos: Integer): String;
function  IntToTime(I: double): string;
function  IntToSize(I: double): string;
function  SizeBlockRead(var FromFile: integer): Integer;
function  SizeBlockWrite(var ToFile: integer; ToWrite: Integer): Integer;

var
	FromF, ToF         : integer;
	NumRead, NumWritten: Integer;

implementation

uses kopy_error, StdCtrls, ComCtrls;

var TTK           : TThreadKopy;
    progress      : Int64;

function FileSizeByName(sFilename: string): Int64;
var sr   : TSearchRec;
begin
  result := 0;
  if FindFirst(sFilename, faAnyFile, sr)=0 then
  begin
      result := sr.FindData.nFileSizeHigh * 4294967295 + sr.FindData.nFileSizeLow;
  end;
  FindClose(sr);
end;

// function for creating strings from numbers
Function countStr(Number, pos: Integer): String;
var zw : String;
begin
  zw := IntToStr(Number);
  If Length(zw) > pos Then pos := Length(zw);
  while Length(zw) <> pos do zw := '0' + zw;
  result := zw;
End;

function IntToTime(I: double): string;
var zw : Integer;
begin
if I > 60 then begin
   zw := Trunc(I) div 60;
   Result := IntToStr(zw) + ':' + countStr(Trunc(I-zw*60), 2) + ' min';
end else
   Result := Format('%1.0f sec',[I])
end;

function IntToSize(I: double): string;
begin
if I > (1024 * 1024 * 1024 * 10.0) then
 begin
 Result := Format('%1.2f Gb',[I / (1024 * 1024 * 1024)])
 end
else
if I > (1024 * 1024) then
 begin
 Result := Format('%1.2f Mb',[I / (1024 * 1024)])
 end
else
if I > 1024 then
 begin
 Result := Format('%1.2f kb',[I / (1024)])
 end
else
Result := Format('%u bytes',[Round(I)]);
end;

// implementation
procedure SysErrMsg(ErrCode: Integer; S: string);
var Len: Integer;
	Buffer: array[0..255] of Char;
begin
  if ErrCode=0 then exit;
	Len := FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM or
		FORMAT_MESSAGE_ARGUMENT_ARRAY, nil, ErrCode, 0, Buffer,
		SizeOf(Buffer), nil);
	while (Len > 0) and (Buffer[Len - 1] in [#0..#32, '.']) do Dec(Len);

  kF.Memo1.Lines.Add(S + IntToStr(ErrCode));
  //MessageDlg(S + IntToStr(ErrCode) + Chr(13) + Buffer, mtError, [mbOK], 0);
end;

procedure delthefile(filename: string; deletefile: boolean);
//const richtig: set of char=[#33..#41,#45,#48..#57,#63..#90,#94..#123,#125..#255];
const richtig: set of char=[#35..#41,#45,#48..#57,#64..#90,#94..#123];
var
  //hFile      : Cardinal;
	F          : Integer;
	OrigAttr   : Integer;
  fsize      : Int64;
	rest, i    : Integer;
	hlpI       : Integer;
	Prozent, lastProzent: double;
	IOR        : Integer;
  c          : char;
  newnfile    : string;
  npath, nfile: string;
begin
// Rename the file a few times
// OverwriteFileName( FileName, lastFileName );
//
// SecureOverwrite
// This function implements a secure santize of rigid (removable
// and fixed) disk media as per the Department of Defense clearing
// and sanitizing standard: DOD 5220.22-M
//
// The standard states that hard disk media is sanatized by
// overwriting with a character, then the character's complement,
// and then a random character. Note that the standard specicically
// states that this method is not suitable for TOP SECRET information.
// TOP SECRET data sanatizing is only achievable by a Type 1 or 2
// degauss of the disk, or by disintegrating, incinerating,
// pulverizing, shreding, or melting the disk.

// Note: no need to flush since the file is opened with write-through or
// no cache buffering

// First, open the file in overwrite mode
// hFile = CreateFile(FileName, GENERIC_WRITE,
//                    FILE_SHARE_READ|FILE_SHARE_WRITE,
//                    NULL, OPEN_EXISTING, FILE_FLAG_WRITE_THROUGH, NULL );

//------------------------------------------------------------------------
// for reasons of speed only one renaming and one overwriting is performed
//------------------------------------------------------------------------

   Randomize;

   if kF.Button3.Cancel and deletefile then begin
	  kF.Label12.Caption := 'deleting file...';
	  kF.Label12.Refresh;
	  try
		  //AssignFile(F, filename);
		  //Erase(F);
      npath:=ExtractFilePath(filename);
      nfile:=ExtractFileName(filename);

      repeat
      for i:=1 to Length(nfile) do begin
          if nfile[i]<>'.' then begin
            c:=#0;
            while not (c in richtig) do
                c:=Chr(random(255));
            newnfile:=newnfile+c;
          end else begin
            newnfile:=newnfile+'.';
          end;
      end;
      until not FileExists(npath+newnfile);

      if not RenameFile(npath+nfile, npath+newnfile) then
          kF.Memo1.Lines.Add('  rename: ' + npath+newnfile);
      if not SysUtils.DeleteFile(npath+newnfile) then
          kF.Memo1.Lines.Add('  delete: ' + npath+newnfile);

///////////////////////////////////////////////////////////////////////////
	  except
		  on EInOutError do
			  kF.Memo1.Lines.Add('not closed: ' + filename);
	  end;
	  kF.Label12.Caption := '';
	  kF.Label12.Refresh;
	  Exit;
   end;

   OrigAttr := FileGetAttr(filename);

   // set attributes if needed
   if ((OrigAttr and faReadOnly) = faReadOnly) or
    //((OrigAttr and faArchive) = faArchive) or
	  ((OrigAttr and faSysFile) = faSysFile) or
	  ((OrigAttr and faHidden) = faHidden) then
	  if ( FileSetAttr(filename, 0) <> 0 ) then begin
		 kF.Memo1.Lines.Add('not set attr:' + filename);
	  end;

   F:=FileOpen(Filename, fmShareDenyWrite OR fmOpenWrite);
   if (F=-1) then begin
     kF.Memo1.Lines.Add('not r+ opened: ' + filename);
	   Exit;
   end;
   fsize := FileSizeByName(filename);

   kF.lbprog.Caption:='0';
   kF.Label8.Caption := FloatToStrF(fsize, ffNumber, 15, 0); //kF.FmtStr(fsize, 2, '.', 0);
   kF.Label8.Refresh;
   kF.lbprogtotal.Caption := '0';
   kF.Label13.Caption := filename;
   kF.Label14.Caption := '';
   kF.Label12.Caption := 'overwrite';
   kF.lbprog.Caption  := '0';
   kF.progbar1.Position := 0;
   rest := fsize mod blocksize;
   hlpI := Trunc((fsize - rest) / blocksize);

   for i := 1 to hlpI do begin
	   kF.ActWin;
	   if not kF.Button3.Cancel then Break;

     if lastEdit6Text <> kF.Edit6.Text then begin
       // make blocksize from list-value
       FreeMem(CopyBuffer,blocksize);
       Val(kF.Edit6.Text, blocksize, val_code);
       GetMem(CopyBuffer, blocksize);
       ZeroMemory(CopyBuffer, blocksize);
       vis_faktor      := blocksize;
       lastEdit6Text   := kF.Edit6.Text;
     end;

	   NumWritten := SizeBlockWrite(F, blocksize);
     if (numwritten<0) then break;
	   lastsize := lastsize + numwritten;
	   Prozent  := (i * blocksize / fsize) * 100.0;
	   if Prozent > 100 then Prozent := 100;

	   // for the eyes
     if (RoundTo(Prozent, -2) > lastProzent) then begin
       lastProzent := RoundTo(Prozent, -2);
  		 kF.progbar1.Position := Trunc(Prozent*100);
	 	   kF.progbar2.Position := Trunc(lastsize/c_bytes_total*10000);
	  	 kF.lbprog.Caption := FloatToStrF(progress, ffNumber, 15, 0);
		   kF.lbprogtotal.Caption := FloatToStrF(lastsize, ffNumber, 15, 0);
		   kF.lbproz.Caption := FloatToStrF(Prozent, ffNumber, 15, 2) + '%';
		   kF.lbproztotal.Caption := FloatToStrF(lastsize/c_bytes_total*100, ffNumber, 15, 2) + '%';

		   kF.lbprog.Refresh;
		   kF.lbprogtotal.Refresh;
		   kF.lbproz.Refresh;
		   kF.lbproztotal.Refresh;
     end;
   end;

   if kF.Button3.Cancel then  begin
	   NumWritten := SizeBlockWrite(F, rest);
	   kF.progbar1.Position := kF.progbar1.Max;
	   Prozent := 100;
   end;

   if (Prozent < 100) then begin
	  kF.lbproz.Caption := 'canceled at ';
	  kF.Panel2.Caption := '';
	  kF.lbproztotal.Caption := FloatToStrF(lastsize/c_bytes_total*100, ffNumber, 15, 2) + '%';
	  kF.Memo1.Lines.Add('not finished: "' + filename + '" (' +
		  FloatToStrF(progress, ffNumber, 15, 0) + ' / ' +
		  FloatToStrF(fsize, ffNumber, 15, 0) + ' byte)');
   end else begin
		kF.lbproz.Caption := '';
		kF.lbproztotal.Caption := '100,00%';
   end;

   kF.Label12.Caption := 'closing src..';
   kF.Label12.Refresh;
   FileClose(F);
   kF.Label12.Caption := '';
   kF.Label12.Refresh;
end;

procedure kopythefile(Quelle, Ziel: string);
var
	OrigTime, OrigAttr          : Integer;
	DestAttr                    : Integer;
	i, ret, versuche            : Longint;
	l_filesize, l_dest_filesize : Int64;
	anzahl                      : Int64;
	IOR                         : Integer;
	s_tmp                       : string;
	Prozent, lastProzent        : double;
  err                         : Cardinal;
	bError                      : Boolean;
  goout                       : Boolean;
begin
	anzahl   := 0;
	progress := 0;
	prozent  := 0;
  lastProzent := 0;
  goout:=FALSE;
	bError   := False;
	Val(kF.Edit5.Text, versuche, val_code);

	OrigTime := FileAge(Quelle);
	OrigAttr := FileGetAttr(Quelle);

	(*
  if ((OrigAttr and faReadOnly) = faReadOnly) or
	   ((OrigAttr and faSysFile)  = faSysFile ) or
	   ((OrigAttr and faHidden)   = faHidden  ) then
	if (FileSetAttr(Quelle, 0) <> 0) then begin
		Memo1.Lines.Add('not set attr:' + Quelle);
	end;
  *)

  l_filesize := FileSizeByName(Quelle);
  FromF:=FileOpen(Quelle, fmOpenRead OR fmShareDenyNone);
  if FromF<0 then begin
		kF.Memo1.Lines.Add('not opened (' + IntToStr(IOR) + '): ' + Quelle);
		// {$I-} CloseFile(FromF); {$I+}
    FileClose(FromF);
		//FileSetAttr(Quelle, OrigAttr);
		lasttime := 0;
		Exit;
	end;

	if (FileExists(Ziel) and kF.ckb1.Checked) then begin
    // open existing file
		DestAttr := FileGetAttr(Quelle);
		if ((DestAttr and faReadOnly) = faReadOnly) or
		   ((DestAttr and faArchive) = faArchive) or
		   ((DestAttr and faSysFile) = faSysFile) or
		   ((DestAttr and faHidden) = faHidden) then
			FileSetAttr(Ziel, 0);

    l_dest_filesize := FileSizeByName(Ziel);

    ToF:=FileOpen(Ziel, fmOpenWrite OR fmShareDenyNone);
    SysErrMsg(GetLastError, 'open: ');
    //CreateFile(
    //FileSeek(hf, l_filesize, 0);
    //SetFilePointer(hFile, l_filesize, nil, FILE_BEGIN);
    //SetEndOfFile(hf);
    if ToF<0 then begin
			//FileSetAttr(Quelle, OrigAttr);
			//{$I-}CloseFile(FromF);{$I+}
			//{$I-}CloseFile(ToF);{$I+}
      FileCLose(FromF);
      FileCLose(ToF);
			lasttime := 0;
			Exit;
		end;

		if (l_dest_filesize = l_filesize) then begin
			// file already there
			//{$I-} CloseFile(FromF); {$I+}
			//{$I-} CloseFile(ToF); {$I+}
      FileCLose(FromF);
      FileCLose(ToF);
			//FileSetAttr(Quelle, OrigAttr);
			progress := l_dest_filesize;
			lastsize := lastsize + progress;
			kF.progbar2.Position := Trunc(lastsize/c_bytes_total*10000);
			lasttime := 0;
			//kF.progbar2.Refresh;
			//kF.lbprogtotal.Caption := FloatToStrF(lastsize, ffNumber, 15, 0);
			//kF.lbprogtotal.Refresh;
			Exit;
		end;

		progress := l_dest_filesize;
		lastsize := lastsize + progress;
		if (l_dest_filesize > 0) then begin
			kF.Label12.Caption := 'appending';

      // create non fragmented file !!!
      //FileSeek(ToF, l_filesize, 0);
      //SetEndOfFile(ToF);

      if FileSeek(FromF, l_dest_filesize, 0) = -1 then begin
        SysErrMsg(GetLastError, 'seeksrc: ');
        goout:=TRUE;
      end;
      SysErrMsg(GetLastError, 'seeksrc: ');

      if FileSeek(ToF, l_dest_filesize, 0) = -1 then begin
        SysErrMsg(GetLastError, 'seekdest: ');
        goout:=TRUE;
      end;
      SysErrMsg(GetLastError, 'seekdest: ');

      if goout then begin
				if kF.ClientHeight<360 then kF.ClientHeight := 360;
				kF.Memo1.Lines.Add('not positioned: ' +
				Quelle + ' at: ' +
				IntToStr(progress));
				//{$I-}CloseFile(FromF);{$I+}
				//{$I-}CloseFile(ToF);{$I+}
        FileCLose(FromF);
        FileCLose(ToF);

				//FileSetAttr(Quelle, OrigAttr);
				kF.progbar2.Position := Trunc(lastsize/c_bytes_total*100);
				kF.lbprogtotal.Caption := FloatToStrF(progress, ffNumber, 15, 0);
				lasttime := 0;
				Exit;
      end;
		end else begin
			kF.Label12.Caption := 'new created';
		end
	end else begin
		//AssignFile(ToF, Ziel); { Open new output-file }
		//FileMode := fmOpenReadWrite or fmShareDenyWrite;
		//Rewrite(ToF, 1); { record size = 1 }
    ToF:=FileCreate(Ziel);
    //ToF:=FileOpen(Ziel, fmCreate);
    if ToF < 1 then begin
      SysErrMsg(GetLastError, 'open: ');
      FileCLose(FromF);
		  lasttime := 0;
			Exit;
    end;

    // try to create a non fragmented file !!!
    if (SetFilePointer(ToF, l_filesize, nil, FILE_BEGIN) = -1) then begin
      err:=GetLastError();
      kf.Memo1.Lines.Add('..could not set end of file..'+ SysErrorMessage(err));
    end;

    if not SetEndOfFile(ToF) then begin
      err:=GetLastError();
      kf.Memo1.Lines.Add('..could not set end of file..'+ SysErrorMessage(err));
    end;

    if (err=112) then begin
      kF.Button3.Cancel := False;
			kF.Button3.Caption := '&kopy';
      FileCLose(FromF);
      FileCLose(ToF);
		  //lasttime := 0;
			Exit;
    end;
    SetFilePointer(ToF, 0, nil, FILE_BEGIN);
	end;

	kF.Label8.Caption := FloatToStrF(l_filesize, ffNumber, 15, 0);
  if (l_filesize>0)then
  	kF.progbar1.Position := Trunc(progress/l_filesize*10000);
	kF.progbar2.Position:=Trunc(lastsize/c_bytes_total*10000);
	kF.lbprog.Caption := FloatToStrF(progress, ffNumber, 15, 0);
	kF.lbprogtotal.Caption := FloatToStrF(lastsize, ffNumber, 15, 0);
  if (l_filesize>0)then
  	kF.lbproz.Caption := FloatToStrF(progress/l_filesize*100, ffNumber, 15, 2) + '%';
	kF.lbproztotal.Caption:= FloatToStrF(lastsize/c_bytes_total*100, ffNumber, 15, 2) + '%';
	kF.Label13.Caption := Quelle;
	kF.Label14.Caption := Ziel;

  kF.Repaint;

	repeat
	  kF.ActWin;
	  if not kF.Button3.Cancel then break;
	  NumWritten := 0;
	  NumRead := 0;

    if lastEdit6Text <> kF.Edit6.Text then begin
       // make blocksize from list-value
       FreeMem(CopyBuffer,blocksize);
       Val(kF.Edit6.Text, blocksize, val_code);
       GetMem(CopyBuffer, blocksize);
       vis_faktor      := blocksize;
       lastEdit6Text   := kF.Edit6.Text;
    end;

	  TTK := TThreadKopy.Create;
	  TTK.WaitFor;
	  TTK.Free;

	  if (NumRead < 0) then begin // try wrong
	  //if SizeBlockRead(FromF, NumRead) <> 0 then begin // try was wrong
		 repeat // try until success OR cancel
			//schublade offen und abbrechen
			kF.Repaint;
			kF.ActWin;
			if not kF.Button3.Cancel then break;

			Val(kF.Edit5.Text, versuche, val_code);
			Inc(anzahl);
			kF.Panel2.Caption := IntToStr(anzahl);
			kF.Panel2.Refresh;

			kF.ActWin;
			if not kF.Button3.Cancel then break;

			// make blocksize smaller
			if (kF.ckb3.Checked) then
			if (kF.Edit6.ItemIndex > 0) and not bError then begin
				spinupval := StrToInt(kF.Edit6.Items[kF.Edit6.ItemIndex-1]);
				kF.Edit6.ItemIndex := kF.Edit6.ItemIndex - 1;
				kF.Edit6.Refresh;
				// make blocksize from list-value
				Val(kF.Edit6.Text, blocksize, val_code);
				vis_faktor := blocksize;
				kF.Memo1.Lines.Add('changed blocksize down to ' + IntToStr(blocksize));
				Dec(anzahl); //:=0;
			end;

			kF.ActWin;
			if not kF.Button3.Cancel then break;

			// let drive cool down for a second before next try 
			// dont know of it is worth it !?
			if anzahl > 1 then
				for i:=0 to 4 do begin
					Sleep(200);
					kF.ActWin;
				end;

			NumRead := 0;
			//TTK := TThreadKopy.Create;
			//TTK.WaitFor;
			//TTK.Free;

      if SizeBlockRead(FromF) < 0 then begin // try wrong
			//if (NumRead < 0) then begin          // try wrong
			   kF.Repaint;
			   kF.ActWin; // dont quit here with break

			   Val(kF.Edit5.Text, versuche, val_code);

			   if (anzahl >= versuche) then begin
				  if not notoall then begin //retry
					 if yestoall then begin 
						anzahl := 0;
						Break;
					 end;
					 if breakonerror then begin
						Break;
					 end;
					 ret := MessageDlg(
					   'Ignore this block and write NULL? "No" repeats. "All No" repeats forever.',
					   mtConfirmation, mbYesAllNoAllCancel, 0);
					 case ret of
						mrNoToAll: begin anzahl := 0;
							  notoall := True;
						   end; //wdrhle lfd
						mrNo: anzahl := 0; //wiederhole
						mrYes: begin
							  anzahl := 0;
							  Break;
						   end; //ignore
						mrYesToAll: begin anzahl := 0;
							  yestoall := True;
							  Break;
						   end; //ignore all
						mrCancel: begin //abbrechen
							  if ((Pos('*', kF.Edit1.text) <> 0) or
  								  (Pos('?', kF.Edit1.text) <> 0)    ) and
	  							  (c_files_total > 1) then begin
								 ret := MessageDlg('Cancel all files on read-error?',
									mtConfirmation, mbOKCancel, 0);
								 case ret of //alle bei fehler abbr.
									mrOk: begin
										  breakonerror := True;
										  Break;
									   end;
									mrCancel: Break; //nur 1x abbr.
								 end;
							  end else begin
								 kF.Button3.Cancel := False;
								 kF.Button3.Caption := '&kopy';
                 breakonerror := True;
								 Break;
							  end;
						   end;
					 end; //case
          end else begin
            anzahl:=0;
				  end; //retry
			   end; // if anz > versuche
			end else begin // try was ok
			   // after a while we have a winner

			   kF.Repaint;
			   kF.ActWin; // dont quit here with break

			   if (anzahl<1) then anzahl:=1;
			   s_tmp := '  after ' + IntToStr(anzahl) + ' tries ' + IntToStr(NumWritten) +
						' byte at position ' + FloatToStrF(progress, ffNumber, 15, 0) + ' written';

			   //Writeln(logfile, s_tmp);
			   //logfile.Write(PChar(s_tmp)^, Length(s_tmp));
			   //logfile.Write(PChar(Chr(13) + Chr(10))^, 2);
			   kF.Memo1.Lines.Add(s_tmp);

			   Inc(spinupcounter, spinupval);
			   bError := false;

			   kF.Panel2.Caption:='';
			   kF.Panel2.Refresh;
			   anzahl:=0;
			   Inc(spinupcounter, spinupval);
			   break;

			   kF.ActWin;
			   if not kF.Button3.Cancel then break;
			end;
		 until (l_filesize = 0) or (progress = l_filesize) or (anzahl>=versuche);

		 bError := true;

		 if breakonerror and (NumWritten=0) and (kF.Button3.Cancel) then begin
			Inc(c_error, 1);
			kF.Panel1.Caption := IntToStr(c_error);
			s_tmp := Quelle + ': error #' + s_tmp + ': at position ' + IntToStr(progress) + ' not read';
			//writeln(logfile, s_tmp);
			//logfile.Write(PChar(s_tmp)^, Length(s_tmp));
			//logfile.Write(PChar(Chr(13) + Chr(10))^, 2);
			kF.Memo1.Lines.Add(s_tmp);
			Break;
		 end;

		 kF.ActWin;
		 if not kF.Button3.Cancel then break;

		 // write empty block
		 if ((NumWritten = 0) and (kF.Button3.Cancel)) or 
  			((NumWritten = 0) and yestoall) then 
     begin
			Inc(c_error, 1);
			Str(c_error, s_tmp);
			s_tmp := Quelle + ': error #' + s_tmp + ': at position ' + IntToStr(progress) + ' - ' + 
					 IntToStr(blocksize) + 'x NULL written';
			kF.Memo1.Lines.Add(s_tmp);

      FreeMem(CopyBuffer,blocksize);
      Val(kF.Edit6.Text, blocksize, val_code);
      GetMem(CopyBuffer, blocksize);
      ZeroMemory(CopyBuffer, blocksize);
      vis_faktor      := blocksize;
      lastEdit6Text   := kF.Edit6.Text;
      NumWritten := SizeBlockWrite(ToF, NumRead);
		  kF.ActWin;

			//writeln(logfile, s_tmp);
			//logfile.Write(PChar(s_tmp)^, Length(s_tmp));
			//logfile.Write(PChar(Chr(13) + Chr(10))^, 2);
		 end;

		 progress := progress + blocksize;
		 lastsize := lastsize + blocksize;

		 //Seek(FromF, progress); // next sektor
     FileSeek(FromF, progress, 0);

		 kF.Panel1.Caption := IntToStr(c_error);
		 kF.Panel2.Caption := '';

		 Inc(spinupcounter, spinupval);
		 // make blocksize greater
		 if (kF.ckb3.Checked) then
		 if (kF.Edit6.ItemIndex < greatestblockindex) and
			(spinupcounter>=StrToInt(kF.Edit6.Items[kF.Edit6.ItemIndex+1])) then begin
			 kF.Edit6.ItemIndex := kF.Edit6.ItemIndex + 1;
			 kF.Edit6.Refresh;
			 if kF.Edit6.ItemIndex = greatestblockindex then spinupval := 0;
			 spinupcounter := 0;
			 spinupval := StrToInt(kF.Edit6.Items[kF.Edit6.ItemIndex]);
			 // make blocksize from list-value
			 Val(kF.Edit6.Text, blocksize, val_code);
			 vis_faktor       := blocksize;
			 kF.Memo1.Lines.Add('changed blocksize up to ' + IntToStr(blocksize));
		 end;

		 kF.ActWin;
		 if not kF.Button3.Cancel then break;
	  end else begin

		 // all was ok, write to file
     //if FileWrite(ToF, CopyBuffer^, NumRead) < 0 then begin
     NumWritten := SizeBlockWrite(ToF, NumRead);
		 if NumWritten < 0 then begin
			kF.Memo1.Lines.Add('cannot write data: ' + Ziel);
			break;
		 end;

		 if (anzahl>0) or bError then begin
			 s_tmp := '  continue after some errors at position ' + FloatToStrF(progress, ffNumber, 15, 0);
			 kF.Memo1.Lines.Add(s_tmp);
			 anzahl := 0;
			 bError := false;
		 end;
		 bError := False;

		 Inc(spinupcounter, spinupval);
		 // make blocksize greater
		 if (kF.ckb3.Checked) then
		 if (kF.Edit6.ItemIndex < greatestblockindex) and
			(spinupcounter>=StrToInt(kF.Edit6.Items[kF.Edit6.ItemIndex+1])) then begin
			 kF.Edit6.ItemIndex := kF.Edit6.ItemIndex + 1;
			 kF.Edit6.Refresh;
			 if kF.Edit6.ItemIndex = greatestblockindex then spinupval := 0;
			 spinupcounter := 0;
			 spinupval := StrToInt(kF.Edit6.Items[kF.Edit6.ItemIndex]);
			 // make blocksize from list-value
			 Val(kF.Edit6.Text, blocksize, val_code);
			 vis_faktor       := blocksize;
			 kF.Memo1.Lines.Add('changed blocksize up to ' + IntToStr(blocksize));
		 end;

		 progress := progress + NumWritten;
		 lastsize := lastsize + NumWritten;
	  end;

	  kF.ActWin;
	  if not kF.Button3.Cancel then break;
	  
	  if NumWritten > 0 then Prozent := (progress / l_filesize) * 100
                      else Prozent := 0;
	  if Prozent > 100 then Prozent := 100;

	  // for the eyes
	  if (RoundTo(Prozent, -2) > lastProzent) and ((l_filesize > vis_faktor) or (Prozent = 100)) then begin
      lastProzent := RoundTo(Prozent, -2);
		  kF.progbar1.Position := Trunc(Prozent*100);
		  kF.progbar2.Position := Trunc(lastsize/c_bytes_total*10000);
		  kF.lbprog.Caption := FloatToStrF(progress, ffNumber, 15, 0);
		  kF.lbprogtotal.Caption := FloatToStrF(lastsize, ffNumber, 15, 0);
		  kF.lbproz.Caption := FloatToStrF(Prozent, ffNumber, 15, 2) + '%';
		  kF.lbproztotal.Caption := FloatToStrF(lastsize/c_bytes_total*100, ffNumber, 15, 2) + '%';

		  kF.lbprog.Refresh;
		  kF.lbprogtotal.Refresh;
		  kF.lbproz.Refresh;
		  kF.lbproztotal.Refresh;
	  end;
   until (l_filesize = 0) or (progress >= l_filesize) or (Prozent >= 100);

   if (progress < l_filesize) then begin
     SetEndOfFile(ToF);
	   kF.lbproz.Caption := 'canceled at ';
	   kF.Panel2.Caption := '';
	   kF.lbproztotal.Caption := FloatToStrF(lastsize/c_bytes_total*100, ffNumber, 15, 2) + '%';
	   kF.Memo1.Lines.Add('not finished: "' + Ziel + '" (' +
		 FloatToStrF(progress, ffNumber, 15, 0) + ' / ' +
		 FloatToStrF(l_filesize, ffNumber, 15, 0) + ' byte)');
   end else
		kF.lbproz.Caption := '';

   kF.Label12.Caption := 'close source...';
   kF.Label12.Refresh;
   FileClose(FromF);
   kF.Label12.Caption := 'close destination...';
   kF.Label12.Refresh;
   FileClose(ToF);

   kF.Label12.Caption := 'set destdate...';
   kF.Label12.Refresh;
   FileSetDate(Ziel, OrigTime);
   if (DriveType = 3) or (DriveType = 6) then begin
	  kF.Label12.Caption := 'set destattr...';
	  kF.Label12.Refresh;
	  FileSetAttr(Ziel, OrigAttr);
	  //kF.Label12.Caption := 'set srcattr...';
	  //kF.Label12.Refresh;
	  //FileSetAttr(Quelle, OrigAttr);
   end;
   kF.Label12.Caption := '';
   kF.Label12.Refresh;
end;


function Directories2(SrcPath: string; DestPath: string; filter: string) : Int64;
var
  c_Bytes        : Int64;
  c_bytes_dest   : Int64;
  frei, byteinfo : string;
  k              : integer;

  procedure ScanRecurse(SrcPath: string; DestPath: string; ext: String);
  var   sr             : TSearchRec;
        SearchPath     : string;
  begin
    if not kF.Button3.Cancel then exit;

    Inc(c_paths_total);
  	if not kF.ckb2.Checked and (c_bytes_total > 0) then {$I-} MkDir(DestPath); {$I+}
    SearchPath := SrcPath + ext;
    FindFirst(SearchPath, faAnyFile, sr);
    repeat
      if (sr.Name <> '.') and (sr.Name <> '..') then
        if ((sr.Attr and faDirectory) <> 0) then
        begin
				  // dir - level
          if not kF.Button3.Cancel then exit;
          ScanRecurse(SrcPath + sr.Name + '\', DestPath + sr.Name + '\', ext);

          if kF.ckb2.Checked and overwritten then
			       if not RemoveDir(SrcPath + sr.Name) then
                kF.Memo1.Lines.Add('not removed:' + SrcPath + sr.Name);

        end else begin
          if not kF.Button3.Cancel then exit;

				  // file - level
          Inc(c_files_total);
          c_Bytes := c_Bytes + sr.FindData.nFileSizeHigh*4294967295 + sr.FindData.nFileSizeLow;

 			    if not kF.ckb2.Checked and (c_bytes_total > 0) then {$I-} MkDir(DestPath); {$I+}

				  //writeln(logfile, SrcPath + DirInfo.Name);
				  //s_tmp := SrcPath + DirInfo.Name;
				  //logfile.Write(PChar(s_tmp)^, Length(s_tmp));
				  //logfile.Write(PChar(Chr(13) + Chr(10))^, 2);

				  if not (c_bytes_total = 0) then begin
					    if kF.ckb2.Checked then
			    		  	delthefile(SrcPath + sr.Name, overwritten)
					    else
      					  kopythefile(SrcPath + sr.Name, DestPath + sr.Name);
				  end;
        end;
    until FindNext(sr) <> 0;
    FindClose(sr);
  end;

begin
	c_files_total:= 0;
	c_paths_total:= 0;
	c_bytes      := 0;
	c_bytes_dest := 0;
  k:=1;

  ScanRecurse(SrcPath, DestPath, filter);
  result := c_bytes;
end;

function Directories1(SrcPath: string; DestPath: string; filter: string) : Int64;
var
	DirInfo     : TSearchRec;
	c_bytes     : Int64;
	c_dir_bytes, c_bytes_dest : Int64;
	c_dir_files : LongWord;
	c_dir_paths : LongWord;
	return, L   : Integer;
	O_Laenge    : Byte;
	Last_Direc, Old_Path: string;
	dirlevel    : Integer;

	function files(dir: string): Int64;
	begin
		c_dir_bytes := 0;
		return := FindFirst(dir+Filter, faAnyFile, DirInfo);
		while return = 0 do begin
		   kF.ActWin;
		   if not kF.Button3.Cancel then break;

		   if ((Dirinfo.Attr and faDirectory) = 0) then begin
			  // file - level
			  Inc(c_dir_files);
			  Inc(c_dir_bytes, DirInfo.Size);

			  //writeln(logfile, SrcPath + DirInfo.Name);
			  //s_tmp := SrcPath + DirInfo.Name;
			  //logfile.Write(PChar(s_tmp)^, Length(s_tmp));
			  //logfile.Write(PChar(Chr(13) + Chr(10))^, 2);

			  if not (c_bytes_total = 0) then begin
				    if kF.ckb2.Checked then
		    		  	delthefile(SrcPath + DirInfo.Name, overwritten)
				    else
    					  kopythefile(SrcPath + DirInfo.Name, DestPath + DirInfo.Name);
			  end;
		   end;
		   return := FindNext(DirInfo);
		end;
		FindClose(DirInfo);
		result:=c_dir_bytes;
	end;
	
begin
	c_files_total:= 0;
	c_paths_total:= 0;
	c_dir_paths  := 0;
	c_dir_files  := 0;
	c_dir_bytes  := 0;
	c_bytes      := 0;
	c_bytes_dest := 0;
	dirlevel     := 0;

	Last_Direc   := '';
	O_Laenge     := Length(SrcPath)-1;
	L := O_Laenge + 1;

	if not kF.ckb2.Checked and (c_bytes_total > 0) then {$I-} MkDir(DestPath); {$I+}
	(*if IOResult <> 0 then begin
	  Memo1.SetSelTextBuf( PChar('not created: DIR ' + DestPath + Chr(13) + Chr(10)) );
	end;*)

	repeat
	  kF.ActWin;
	  if Not kF.Button3.Cancel then break;

	  return := FindFirst(SrcPath+Filter, faAnyFile, DirInfo);
	  if Last_Direc<>'' then begin {if1}          { Suche_altes_Directory }
		 while ( (Last_Direc<>DirInfo.Name) or
			   ((Dirinfo.Attr and faDirectory) = 0) and
			   (return = 0) ) do begin

			// fucking workaround start
			if kF.ckb2.Checked and overwritten and
			   ((Dirinfo.Attr and faDirectory) = 0) then begin
			   if return <> 0 then begin
				  Last_Direc := '';
				  break;
			   end;
			   delthefile(SrcPath + DirInfo.Name, overwritten);
			end;
			// fucking workaround end

			kF.ActWin;
			if Not kF.Button3.Cancel then break;
			return := FindNext(DirInfo);
		 end;
		 if (Last_Direc=DirInfo.Name) and ((Dirinfo.Attr and faDirectory) <> 0) then begin
			Last_Direc:='';
			return := FindNext(DirInfo)
		 end;
	  end; {if1}

	  if Last_Direc='' then begin {if2}
		 Old_Path:=SrcPath;
		 while (return = 0) and (Old_Path=SrcPath) do begin
			kF.ActWin;
			if Not kF.Button3.Cancel then break;

			if ((Dirinfo.Attr and faDirectory) <> 0) and 
			   (DirInfo.Name<>'.') and (DirInfo.Name<>'..') then begin

			   // dir - level
			   Inc(c_dir_paths);
			   SrcPath  := SrcPath  + DirInfo.Name + '\';
			   DestPath := DestPath + DirInfo.Name + '\';

			   if not kF.ckb2.Checked and (c_bytes_total > 0) then {$I-} MkDir(DestPath); {$I+}
			   (*if IOResult <> 0 then begin
					   Memo1.SetSelTextBuf( PChar('not created: DIR ' + DestPath + Chr(13) + Chr(10)) );
					end;*)
					if (c_bytes_total = 0) then begin
						kF.Label13.Caption := SrcPath;
						kF.Label13.Refresh;
			   end;

			end else 
					return := FindNext(DirInfo)
		 end;
			FindClose(DirInfo);

		 Inc(c_paths_total, c_dir_paths);
		 c_dir_paths:=0;
		 c_dir_files:=0;
		 c_dir_bytes:=0;

		 if Old_Path=SrcPath then begin
{dat}       if not kF.Button3.Cancel then break;
			
			c_dir_bytes := files(SrcPath);
			Inc(c_bytes      , c_dir_bytes);
			Inc(c_files_total, c_dir_files);
			
			if (Length(DestPath)>3) and (c_bytes_total = 0) then begin
				c_dir_bytes := files(DestPath);
				Inc(c_bytes_dest, c_dir_bytes);
			end;
{dat}     	

			if kF.ckb2.Checked and overwritten then begin
			   {I-} RmDir(SrcPath + Last_Direc); {I+}
			   if IOResult<>0 then begin
				  kF.Memo1.SetSelTextBuf( PChar('not removed:' + SrcPath + Last_Direc + Chr(13) + Chr(10)) );
			   end;
			end;

{cd}  L  := Length(SrcPath); // detach old path
			while (SrcPath[L - 1] <> '\') and (L>2) do Dec(L);
			Dec(L);
			Last_Direc := Copy(SrcPath, L + 1, Length(SrcPath)-L-1);
			SrcPath := Copy(SrcPath,     1, L);
{cd}  DestPath:= Copy(DestPath,    1, Length(DestPath) - Length(Last_Direc) - 1);
		 end;
	  end; {if2}
   until (L < O_Laenge);   // stop if origin pathlength or less
   result := c_bytes;
   if (c_bytes_total = 0) then
	  c_bytes_destination := c_bytes_dest;
end; // directories1

function SizeBlockRead(var FromFile: integer): Integer;
begin
    Result := 0;
    Result := FileRead(FromFile, CopyBuffer^, blocksize);
(*
   case kF.Edit6.ItemIndex of
	  11: {$I-}NumRead:=FileRead(FromF, buf419, 4194304);{$I+}
	  10: {$I-}NumRead:=FileRead(FromF, buf209, 2097152);{$I+}
	  9 : {$I-}NumRead:=FileRead(FromF, buf524, 524288 );{$I+}
	  8 : {$I-}NumRead:=FileRead(FromF, buf131, 131072 );{$I+}
	  7 : {$I-}NumRead:=FileRead(FromF, buf327, 32768  );{$I+}
	  6 : {$I-}NumRead:=FileRead(FromF, buf819, 8192   );{$I+}
	  5 : {$I-}NumRead:=FileRead(FromF, buf204, 2048   );{$I+}
	  4 : {$I-}NumRead:=FileRead(FromF, buf512, 512    );{$I+}
	  3 : {$I-}NumRead:=FileRead(FromF, buf128, 128    );{$I+}
	  2 : {$I-}NumRead:=FileRead(FromF, buf32 , 32     );{$I+}
	  1 : {$I-}NumRead:=FileRead(FromF, buf8  , 8      );{$I+}
	  0 : {$I-}NumRead:=FileRead(FromF, buf1  , 1      );{$I+}
   else
	  {$I-}NumRead:=FileRead(FromF, Buf204, 2048);{$I+}
   end;
*)
end;

function SizeBlockWrite(var ToFile: integer; ToWrite: Integer): Integer;
begin
    Result := 0;
    Result := FileWrite(ToFile, CopyBuffer^, ToWrite);
(*
   case kF.Edit6.ItemIndex of
	  11: {$I-}NumWritten:=FileWrite(ToF, buf419, NumRead);{$I+}
	  10: {$I-}NumWritten:=FileWrite(ToF, buf209, NumRead);{$I+}
	  9 : {$I-}NumWritten:=FileWrite(ToF, buf524, NumRead);{$I+}
	  8 : {$I-}NumWritten:=FileWrite(ToF, buf131, NumRead);{$I+}
	  7 : {$I-}NumWritten:=FileWrite(ToF, buf327, NumRead);{$I+}
	  6 : {$I-}NumWritten:=FileWrite(ToF, buf819, NumRead);{$I+}
	  5 : {$I-}NumWritten:=FileWrite(ToF, buf204, NumRead);{$I+}
	  4 : {$I-}NumWritten:=FileWrite(ToF, buf512, NumRead);{$I+}
	  3 : {$I-}NumWritten:=FileWrite(ToF, buf128, NumRead);{$I+}
	  2 : {$I-}NumWritten:=FileWrite(ToF, buf32 , NumRead);{$I+}
	  1 : {$I-}NumWritten:=FileWrite(ToF, buf8  , NumRead);{$I+}
	  0 : {$I-}NumWritten:=FileWrite(ToF, buf1  , NumRead);{$I+}
   else
	  {$I-}NumWritten:=FileWrite(ToF, Buf204, 2048);{$I+}
   end;
*)
end;

end.

